local BHS = CreateFrame("Frame", nil, UIParent)
---
BHS.Regen = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_ManaRegen", {
	label = "Manaregen", 
	type = "data source", 
	icon = "Interface\\Icons\\Spell_Magic_ManaGain",
	text = "0", 
	value = "0", 
	suffix = "mp5", 
	OnTooltipShow = function(regentooltip)
	if not regentooltip or not regentooltip.AddLine then return end
    regentooltip:AddLine( BHS.Regen.tooltiptext )
	end,	
})
BHS.Power = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_SpellPower", {
	label = "Spellpower", 
	type = "data source", 
	icon = "Interface\\Icons\\Spell_Shadow_TwistedFaith",
	text = "0", 
	value = "0", 
	suffix = "pts",
	OnTooltipShow = function(powertooltip)
	if not powertooltip or not powertooltip.AddLine then return end
    powertooltip:AddLine("Spellpower")
    powertooltip:AddDoubleLine("Holy:", BHS.Power.Holy)
    powertooltip:AddDoubleLine("Fire:", BHS.Power.Fire)
    powertooltip:AddDoubleLine("Nature:", BHS.Power.Nature)
    powertooltip:AddDoubleLine("Frost:", BHS.Power.Frost)
    powertooltip:AddDoubleLine("Shadow:", BHS.Power.Shadow)
    powertooltip:AddDoubleLine("Arcane:", BHS.Power.Arcane)
	end,	
})
BHS.Crit = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_SpellCrit", {
	label = "Spellcrit", 
	type = "data source", 
	icon = "Interface\\Icons\\Spell_Shadow_Teleport",
	text = "0", 
	value = "0", 
	suffix = "%",
	OnTooltipShow = function(crittooltip)
	if not crittooltip or not crittooltip.AddLine then return end
    crittooltip:AddLine("Spellcrit")
    crittooltip:AddDoubleLine("Holy:", BHS.Crit.Holy, "%")
    crittooltip:AddDoubleLine("Fire:", BHS.Crit.Fire, "%")
    crittooltip:AddDoubleLine("Nature:", BHS.Crit.Nature, "%")
    crittooltip:AddDoubleLine("Frost:", BHS.Crit.Frost, "%")
    crittooltip:AddDoubleLine("Shadow:", BHS.Crit.Shadow, "%")
    crittooltip:AddDoubleLine("Arcane:", BHS.Crit.Arcane, "%")
	end,	
	
})
BHS.Haste = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_SpellHaste", {
	label = "Spellhaste", 
	type = "data source", 
	icon = "Interface\\Icons\\Ability_Rogue_Sprint",
	text = "0", 
	value = "0", 
	suffix = "%"
})
BHS.Hit = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_SpellHit", {
	label = "Spellhit", 
	type = "data source", 
	icon = "Interface\\Icons\\Spell_Shadow_ShadowEmbrace",
	text = "0", 
	value = "0", 
	suffix = "%"
})
---

BHS.UpdateInterval = 0.2
BHS.missing_mana = UnitManaMax"player" - UnitMana"player"
BHS.time_in_fsr = 0

---

function BHS:Update()
--- Regen
	local out_of_fsr, in_fsr = GetManaRegen()

    if self.time_in_fsr > 4 then
        self.Regen.value = format("%s %d", ".....", in_fsr * 5)
    elseif self.time_in_fsr > 3 then
       	self.Regen.value = format("%s %d", " ....", in_fsr * 5)
    elseif self.time_in_fsr > 2 then
        self.Regen.value = format("%s %d", "  ...", in_fsr * 5)
    elseif self.time_in_fsr > 1 then
        self.Regen.value = format("%s %d", "   ..", in_fsr * 5)
    elseif self.time_in_fsr > 0 then
        self.Regen.value = format("%s %d", "    .", in_fsr * 5)
    else
        self.Regen.value = format("%d", out_of_fsr * 5)
    end
---
end


BHS:SetScript("OnEvent", function (self, event, ...)
--- Regen
	local new_missing_mana = UnitManaMax"player" - UnitMana"player"
	if new_missing_mana > self.missing_mana then
	    self.time_in_fsr = 5
	end
	self.missing_mana = new_missing_mana
--- Regen Tooltip
	local out_of_fsr, in_fsr = GetManaRegen()
    	self.Regen.tooltiptext = format ("%d %s %d %s", in_fsr * 5, " / ", out_of_fsr * 5, "Mp5")

--- Power
    local power = GetSpellBonusDamage(2)
	if (GetSpellBonusDamage(3) > power) then power = GetSpellBonusDamage(3) end
	if (GetSpellBonusDamage(4) > power) then power = GetSpellBonusDamage(4) end
	if (GetSpellBonusDamage(5) > power) then power = GetSpellBonusDamage(5) end
	if (GetSpellBonusDamage(6) > power) then power = GetSpellBonusDamage(6) end
	if (GetSpellBonusDamage(7) > power) then power = GetSpellBonusDamage(7) end
		self.Power.value = power
		self.Power.Holy = GetSpellBonusDamage(2)
		self.Power.Fire = GetSpellBonusDamage(3)
		self.Power.Nature = GetSpellBonusDamage(4)
		self.Power.Frost = GetSpellBonusDamage(5)
		self.Power.Shadow = GetSpellBonusDamage(6)
		self.Power.Arcane = GetSpellBonusDamage(7)

--- Crit
	local crit = GetSpellCritChance(2)
	if (GetSpellCritChance(3) > crit) then crit = GetSpellCritChance(3) end
	if (GetSpellCritChance(4) > crit) then crit = GetSpellCritChance(4) end
	if (GetSpellCritChance(5) > crit) then crit = GetSpellCritChance(5) end
	if (GetSpellCritChance(6) > crit) then crit = GetSpellCritChance(6) end
	if (GetSpellCritChance(7) > crit) then crit = GetSpellCritChance(7) end
		self.Crit.value = format ("%.2f", crit)
		self.Crit.Holy = format ("%.2f", GetSpellCritChance(2))
		self.Crit.Fire = format ("%.2f", GetSpellCritChance(3))
		self.Crit.Nature = format ("%.2f", GetSpellCritChance(4))
		self.Crit.Frost = format ("%.2f", GetSpellCritChance(5))
		self.Crit.Shadow = format ("%.2f", GetSpellCritChance(6))
		self.Crit.Arcane = format ("%.2f", GetSpellCritChance(7))

--- Haste	
	local haste = format ("%.2f", GetCombatRatingBonus(20))
		self.Haste.value = haste
--- Hit	
	local hit = format ("%.2f", GetCombatRatingBonus(8))
		self.Hit.value = hit
---
		self:Update()
end)


BHS:SetScript("OnUpdate", function (self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate or 0
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed
    local time_in_fsr = self.time_in_fsr or 0
    local new_time_in_fsr = time_in_fsr - elapsed
    self.time_in_fsr = new_time_in_fsr
    if (self.TimeSinceLastUpdate > BHS.UpdateInterval) then
    self:Update()
    self.TimeSinceLastUpdate = 0
  	end
end)

BHS:RegisterEvent("PLAYER_ENTERING_WORLD")
BHS:RegisterEvent("UNIT_MANA")
BHS:RegisterEvent("COMBAT_RATING_UPDATE")
BHS:RegisterEvent("PLAYER_AURAS_CHANGED")